/*
 * File       : js/jt-popup.js
 * Author     : STUDIO-JT (KMS)
 * Guideline  : JTstyle.1.1
 *
 * SUMMARY:
 * 1)
 */



jQuery( function ( $ ) {

    var $container      = $( '#jt_popup_container' );
    var $popup_group    = $( '#jt_popup_playground' );
    var $overlay        = $( '#jt_popup_overlay' );
    var is_mobile       = $container.hasClass( 'mobile' );

    var popup_count     = 0; // Popup Number

    // Popup Cookie Check
    $( '.jt_popup_item' ).each( function () {

        if ( $.cookie( $( this ).attr( 'id' ) ) == 'today_none' ) {

            $( this ).remove();

        } else {

            popup_count++;

        }

    } );

    // Start Device PC Popup
    if ( is_mobile == false ) {

        $( '.jt_popup_item' ).each( function () {

            var $this = $( this );

            $this.imagesLoaded( function () {
				
				// Single Popup (Only One)
				if ( popup_count == 1 &&
					! parseInt( $( '.jt_popup_item' ).css( 'left' ).replace( 'px', '' ) ) &&
					! parseInt( $( '.jt_popup_item' ).css( 'top' ).replace( 'px', '' ) )
				) {

					$( '.jt_popup_item' ).css( {
						'position'    : 'fixed',
						'margin-top'  : - ( $( '.jt_popup_item' ).height() / 2 ) + 'px',
						'margin-left' : - ( $( '.jt_popup_item' ).width() / 2 ) + 'px',
						'top'         : '50%',
						'left'        : '50%'
					} );

				}

                // Show Popup
                if ( ! $overlay.is( ':visible' ) ) {

                    $overlay.fadeIn( 'fast' );

                }

                $this.fadeIn( 'fast' );

                // Popup Drag - jQuery UI
                $this.draggable( {
                    start   : function( event, ui ) {

                                var popupZIndex = 0;

                                $( '.jt_popup_item' ).each( function () {

                                    popupZIndex = ( popupZIndex < parseInt( $( this ).css( 'z-index' ) ) ? parseInt( $( this ).css( 'z-index' ) ) : popupZIndex );

                                } );

                                $this.css( 'z-index', popupZIndex + 1 );

                            }
                } );

            } );

        } );

        // Custom Cursor & Close All Popup
        $overlay
			/*
            .on( 'mousemove', function ( e ) { // show custom cursor

                if ( ! $( '#jt_popup_pc_cursor' ).is( ':visible' ) ) {

                    $( '#jt_popup_pc_cursor' ).show();

                }

                $( '#jt_popup_pc_cursor' ).css( {
                    left    : e.pageX,
                    top     : e.pageY
                } );

            } )
            .on( 'mouseout', function () { // hide custom cursor

                $( '#jt_popup_pc_cursor' ).hide();

            } )
			*/
		
            .on( 'click', function () { // Close All

                $container.fadeOut( 'fast', function () {

                    $( this ).remove();

                } );

            } );

    }
    // End Device PC Popup

    // Start Device Mobile Popup
    if ( is_mobile == true ) {

        // Show Popup
        $popup_group.on( 'init', function ( event, slick ) {

            $overlay.fadeIn( 'fast' );
            $( '#jt_popup_mobile_close_all' ).fadeIn( 'fast' );

            $popup_group.css( {
                opacity     : 1,
                visibility  : 'visible'
            } );

        } );

        // Slider
        $popup_group.slick( {
            slidesToShow    : 1,
            slidesToScroll  : 1,
            infinite        : false,
            autoplay        : false,
            speed           : 300,
            swipeToSlide    : true,
            arrows          : false,
            dots            : false,
            variableWidth   : true,
            centerMode      : false,
            centerPadding   : 0
        } );

        // Close All
        $( '#jt_popup_mobile_close_all' ).on( 'click', function ( e ) {

            e.preventDefault();

            $container.fadeOut( 'fast', function () {

                $( this ).remove();

            } );

        } );

    }
    // End Device Mobile Popup

    // Close Popup
    $( '.jt_popup_close' ).on( 'click', function ( e ) {

        e.preventDefault();

        if ( $( '.jt_popup_item' ).length > 1 ) { // Single

            if ( is_mobile == false ) { // PC

                $( this ).parents( '.jt_popup_item' ).fadeOut( 'fast', function () {

                    $( this ).remove();

                } );

            } else { // Mobile

                $popup_group.slick( 'slickRemove', $( this ).parents( '.jt_popup_item' ).index() );

            }

        } else { // Multiple

            $container.fadeOut( 'fast', function () {

                $( this ).remove();

            } );

        }

    } );

    // Popups Cookie Script
    $( '.jt_popup_notoday' ).on( 'click', function ( e ) {

        e.preventDefault();

        // Set Cookie
        var parent_wrap = $( this ).parents( '.jt_popup_item' );

        $.cookie( parent_wrap.attr( 'id' ), 'today_none', { expires: 1, path: '/' } );

        // Popup Close
        if ( $( '.jt_popup_item' ).length > 1 ) { // Single

            if ( is_mobile == false ) { // PC

                $( this ).parents( '.jt_popup_item' ).fadeOut( 'fast', function () {

                    $( this ).remove();

                } );

            } else { // Mobile

                $popup_group.slick( 'slickRemove', $( this ).parents( '.jt_popup_item' ).index() );

            }

        } else { // Multiple

            $container.fadeOut( 'fast', function () {

                $( this ).remove();

            } );

        }

    } );

} ); // End jQuery